param N;

# Set of cities
set S := 1..N ordered;

# Number of subsets of cities
set SS := 0 .. (2**N - 1);

# Create all subsets of cities
set POW {k in SS} := {i in S: (k div 2**(ord(i)-1)) mod 2 = 1};

# Set of links
set LINKS := {i in S, j in S: i<j};

# Distances between cities
param c {S,S} >= 0;

# Variables X
var X {LINKS} binary;




# Objective to minimize length
minimize TotCost: sum {(i,j) in LINKS} c[i,j] * X[i,j];

# Each city should be visited exactly once.
subj to Tour {i in S}: 
   sum {(i,j) in LINKS} X[i,j] + sum {(j,i) in LINKS} X[j,i]= 2;

# No subtour constraints 1
#subj to SubtourElim1 {k in SS: card(POW[k])<= N-2 and card(POW[k])>=2}:
#     sum {(i,j) in LINKS: i in POW[k] and j in POW[k]} X[i,j] <= card(POW[k])-1;

# No subtour constraints 2
subj to SubtourElim2 {k in SS: card(POW[k])<= N-2 and card(POW[k])>=2}:
     sum {i in POW[k], j in S diff POW[k]: (i,j) in LINKS} X[i,j] +
     sum {i in POW[k], j in S diff POW[k]: (j,i) in LINKS} X[j,i] >= 2;